import { createFilter } from 'rollup-pluginutils';

function glsl() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$include = _ref.include,
        include = _ref$include === undefined ? ['**/*.glsl', '**/*.vs', '**/*.fs'] : _ref$include,
        exclude = _ref.exclude,
        _ref$removeComments = _ref.removeComments,
        removeComments = _ref$removeComments === undefined ? true : _ref$removeComments;

    var filter = createFilter(include, exclude);

    return {
        transform: function transform(code, id) {

            if (!filter(id)) return;

            if (removeComments) {
                code = code.replace(/[ \t]*\/\/.*\n/g, '') // remove //
                .replace(/[ \t]*\/\*[\s\S]*?\*\//g, '') // remove /* */
                .replace(/\n{2,}/g, '\n'); // # \n+ to \n
            }

            var transformedCode = 'export default ' + JSON.stringify(code) + ';';

            return {
                code: transformedCode,
                map: {
                    mappings: ''
                }
            };
        }
    };
}

export default glsl;
//# sourceMappingURL=rollup-plugin-shader.esm.js.map
